/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the DataboxStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DataboxStorageRequest{}

// DataboxStorageRequest struct for DataboxStorageRequest
type DataboxStorageRequest struct {
	Label   *string `json:"label,omitempty"`
	Type    *string `json:"type,omitempty"`
	OAuthId *int32  `json:"o_auth_id,omitempty"`
}

// NewDataboxStorageRequest instantiates a new DataboxStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDataboxStorageRequest() *DataboxStorageRequest {
	this := DataboxStorageRequest{}
	return &this
}

// NewDataboxStorageRequestWithDefaults instantiates a new DataboxStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDataboxStorageRequestWithDefaults() *DataboxStorageRequest {
	this := DataboxStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *DataboxStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataboxStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *DataboxStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *DataboxStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *DataboxStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataboxStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *DataboxStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *DataboxStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *DataboxStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataboxStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *DataboxStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *DataboxStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

func (o DataboxStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DataboxStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	return toSerialize, nil
}

type NullableDataboxStorageRequest struct {
	value *DataboxStorageRequest
	isSet bool
}

func (v NullableDataboxStorageRequest) Get() *DataboxStorageRequest {
	return v.value
}

func (v *NullableDataboxStorageRequest) Set(val *DataboxStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableDataboxStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableDataboxStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataboxStorageRequest(val *DataboxStorageRequest) *NullableDataboxStorageRequest {
	return &NullableDataboxStorageRequest{value: val, isSet: true}
}

func (v NullableDataboxStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataboxStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
